/*
 * Timer min:sec
 *
 * Created: 30.10.2016
 * Author: Sergey Firsov
 */ 

#define F_CPU 4000000UL
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include "n5110.h"

unsigned char takt = 0;
char sek = 0;
unsigned char min=0;
unsigned char dsek = 0;
unsigned char dmin=0;
unsigned char bufer_sek[2];
unsigned char bufer_min[2];
unsigned char bufer_dsek[2];
unsigned char bufer_dmin[2];
unsigned char timer_ON = 0;

ISR (TIMER2_OVF_vect)
{   
	if (timer_ON) {
	  takt++;
	  PORTD |= (1<<PIND0);                                        //  
	  if (takt>=120) {
		  takt=0;
		  if ((dmin>0)&(sek==0)&(dsek==0)&(min==0)) {dmin--; min=9; dsek=5; sek=9;}
			  else {
		     if ((sek==0)&(dsek>0)) {
			   sek=9; dsek--;}
			     else {if (sek>0) {sek--; }	  
		              else {if ((dsek==0)&(sek==0)&(min>0)) {min--; dsek=5; sek=9;}
			       }
			    }
			}
	  }
	  if ((sek==0)&(dsek==0)&(min==0)&(dmin==0)) {timer_ON=0; PORTD &= ~(1<<PIND0); }	  //    
	}
}

void preset() {
	TIMSK |= (1<<TOIE2);
	TCCR2 |= (1<<CS22)|(1<<CS20);          //   1024
	SREG |= (1<<7);
	Lcd_init();
	Lcd_clear();
	LcdContrast(55);
	Lcd_prints(0, 0, FONT_1X,(unsigned char *)PSTR("Digital Spider"));
	Lcd_update();
	DDRC = 0x00;                                 //    
	DDRD = 0xFF;	
}

void checkmin(){
	if (PINC&(1<<PC2)) {                      //  MIN 
		min++;
		if (min>=10) {dmin++; min=0x00;}
		if (dmin>=6) {dmin=0x00;}	
		_delay_ms(200);
		}
}

void checksec(){
	if (PINC&(1<<PC1)) {                      //  SEC
		sek++;
	    if (sek>=10) {dsek++; sek=0x00;}
	    if (dsek>=6) {dsek=0x00;}
		_delay_ms(200);
	}
}

void checkreset(){
	if (PINC&(1<<PC4)) {                      //  RESET
		sek=0; dsek=0;
		min=0; dmin=0;
		_delay_ms(200);
	}
}

void checkstart(){
	if (PINC&(1<<PC0)) {                      //  RESET
		timer_ON = 1;
		_delay_ms(300);
	}
}

int main(void)
{
	preset();
    while(1)
    {
 	  checkmin();
 	  checksec();
 	  checkreset();
 	  checkstart();
      itoa(dmin,bufer_dmin,10);
      Lcd_print(2,3,FONT_2X,(unsigned char*)bufer_dmin);
      itoa(min,bufer_min,10);
      Lcd_print(4,3,FONT_2X,(unsigned char*)bufer_min);
      Lcd_prints(6,3, FONT_2X, (unsigned char*)PSTR(":"));
      itoa(dsek,bufer_dsek,10);
      Lcd_print(8,3,FONT_2X,(unsigned char*)bufer_dsek);
      itoa(sek,bufer_sek,10);
      Lcd_print(10,3,FONT_2X,(unsigned char*)bufer_sek);
      Lcd_update();
    }
}